﻿Imports System.Text
Imports System.Data.Services.Client
Imports Microsoft.WindowsAzure.StorageClient
Imports Microsoft.WindowsAzure


Namespace WorkerRole1
    Friend Class TableStorageEntitiesExample

        'Public Sub CreateAuthorTable()
        '    'need to replace with config settings
        '    Dim StorageAccount As New CloudStorageAccount(
        '        New StorageCredentialsAccountAndKey(
        '            "devstoreaccount1",
        '            "Eby8vdM02xNOcqFlqUwJPLlmEtlCDXJ1OUzFT50uSRZ6IFsuFq2UVErCz4I6tq/K1SZFPTOtr/KBHBeksoGMGw=="),
        '        New Uri("http://127.0.0.1:10000/ "),
        '        New Uri("http://127.0.0.1:10001/ "),
        '        New Uri("http://127.0.0.1:10002/ "))

        '    Dim TableClient = StorageAccount.CreateCloudTableClient()
        '    TableClient.CreateTable("Authors")
        'End Sub

    End Class

    Public Class TableStorageAuthor
        Inherits Microsoft.WindowsAzure.StorageClient.TableServiceEntity
        Private _Id As String
        Public Property Id() As String
            Get
                Return _Id
            End Get
            Set(ByVal value As String)
                _Id = value
            End Set
        End Property
        Private _LastName As String
        Public Property LastName() As String
            Get
                Return _LastName
            End Get
            Set(ByVal value As String)
                _LastName = value
            End Set
        End Property
        Private _FirstName As String
        Public Property FirstName() As String
            Get
                Return _FirstName
            End Get
            Set(ByVal value As String)
                _FirstName = value
            End Set
        End Property
        Private _Phone As String
        Public Property Phone() As String
            Get
                Return _Phone
            End Get
            Set(ByVal value As String)
                _Phone = value
            End Set
        End Property
        Private _Address As String
        Public Property Address() As String
            Get
                Return _Address
            End Get
            Set(ByVal value As String)
                _Address = value
            End Set
        End Property
        Private _City As String
        Public Property City() As String
            Get
                Return _City
            End Get
            Set(ByVal value As String)
                _City = value
            End Set
        End Property
        Private _State As String
        Public Property State() As String
            Get
                Return _State
            End Get
            Set(ByVal value As String)
                _State = value
            End Set
        End Property
        Private _Zip As String
        Public Property Zip() As String
            Get
                Return _Zip
            End Get
            Set(ByVal value As String)
                _Zip = value
            End Set
        End Property
    End Class


    Public Class AuthorDataServiceContext
        Inherits TableServiceContext
        Public ReadOnly Property AuthorData() As IQueryable(Of TableStorageAuthor)
            Get
                Return Me.CreateQuery(Of TableStorageAuthor)("Authors")
            End Get
        End Property


        Public Sub New(ByVal baseAddress As Uri, ByVal credentials As StorageCredentials)
            MyBase.New(baseAddress.AbsoluteUri, credentials)
        End Sub

        Public Sub Add(ByVal author As TableStorageAuthor)

            Me.AddObject("Authors", author)
            Dim dsResponse As DataServiceResponse = SaveChanges()

        End Sub


    End Class
End Namespace
